# https://fedoraproject.org/wiki/Packaging:Haskell
# https://fedoraproject.org/wiki/PackagingDrafts/Haskell

# todo:
# - add core subpackage with no gtk deps

Name:           bluetile
Version:        0.6
Release:        16%{?dist}
Summary:        Tiling window manager for GNOME

License:        BSD
URL:            http://hackage.haskell.org/package/%{name}
Source0:        http://hackage.haskell.org/packages/archive/%{name}/%{version}/%{name}-%{version}.tar.gz
Source1:        bluetile-mate-session
Patch1:         bluetile-0.6-Cabal-version.patch
Patch2:         bluetile-0.6-mate.patch
Patch3:         bluetile-0.6-nolonger-workaround-ICCCMFocus.patch

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
# Begin cabal-rpm deps:
BuildRequires:  ghc-ConfigFile-devel
BuildRequires:  ghc-X11-devel
BuildRequires:  ghc-X11-xft-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-glade-devel
BuildRequires:  ghc-gtk-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-random-devel
BuildRequires:  ghc-regex-compat-devel
BuildRequires:  ghc-unix-devel
BuildRequires:  ghc-utf8-string-devel
BuildRequires:  ghc-xmonad-devel
BuildRequires:  ghc-xmonad-contrib-devel
# End cabal-rpm deps
BuildRequires:  desktop-file-utils
# bluetiledock uses xdg-open
Requires:       xdg-utils
Requires:       mate-terminal

%description
Bluetile is a tiling window manager for Linux, designed to integrate with
the GNOME desktop environment. It provides both a traditional, stacking layout
mode as well as tiling layouts where windows are arranged to use the entire
screen without overlapping. Bluetile tries to make the tiling paradigm easily
accessible to users coming from traditional window managers by drawing on known
conventions and providing both mouse and keyboard access for all features.


%prep
%setup -q
%patch1 -p1 -b .orig
%patch2 -p1 -b .orig
%patch3 -p1 -b .orig


%build
%ghc_bin_build


%install
%ghc_bin_install

install -p -m 0644 -D misc/%{name}-session.desktop %{buildroot}%{_datadir}/xsessions/%{name}.desktop
desktop-file-install --dir=%{buildroot}%{_datadir}/applications misc/%{name}.desktop

install -p -m 0644 -D misc/gnome-bluetile-session.desktop %{buildroot}%{_datadir}/xsessions/bluetile-mate-session.desktop
install -p -m 0755 %{SOURCE1} %{buildroot}%{_bindir}/

mkdir -p %{buildroot}%{_mandir}/man1
install -p -m 0644 man/bluetile.1 %{buildroot}%{_mandir}/man1


%files
%doc LICENSE
%attr(755,root,root) %{_bindir}/%{name}
%attr(755,root,root) %{_bindir}/%{name}-mate-session
%{_libexecdir}/%{name}*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/xsessions/%{name}*.desktop
%{_datadir}/%{name}-%{version}
%{_mandir}/man1/%{name}.1*


%changelog
* Wed Apr  3 2013 Jens Petersen <petersen@redhat.com> - 0.6-16
- rename mate-bluetile-session to bluetile-mate-session (#872590)

* Tue Apr  2 2013 Jens Petersen <petersen@redhat.com> - 0.6-15
- gnome-mate-session is now mate-bluetile-session
- use mate-terminal instead of gnome-terminal
- use xdg-open instead of gnome-open
- do not build broken upstream gnome-bluetile-session
- drop ICCCM takeTopFocus workaround

* Fri Mar 22 2013 Jens Petersen <petersen@redhat.com> - 0.6-14
- use mate-session instead of gnome-session (#872590)

* Sat Feb 23 2013 Kevin Fenzi <kevin@scrye.com> - 0.6-13
- Rebuild for broken deps in rawhide

* Mon Jan 28 2013 Jens Petersen <petersen@redhat.com> - 0.6-12
- build with Cabal >= 1.8 to stop the dependency inheritance between
  the executables (see https://github.com/haskell/cabal/issues/822)

* Fri Jan 18 2013 Jens Petersen <petersen@redhat.com> - 0.6-11
- rebuild

* Tue Nov 20 2012 Jens Petersen <petersen@redhat.com> - 0.6-10
- update with cabal-rpm
- drop README.fedora

* Fri Sep 28 2012 Jens Petersen <petersen@redhat.com> - 0.6-9
- default config assumes gnome-terminal is installed

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jun 21 2012 Jens Petersen <petersen@redhat.com> - 0.6-7
- rebuild

* Fri Jun 15 2012 Jens Petersen <petersen@redhat.com> - 0.6-6
- rebuild

* Wed Mar 14 2012 Jens Petersen <petersen@redhat.com> - 0.6-5
- rebuild

* Fri Feb 24 2012 Jens Petersen <petersen@redhat.com> - 0.6-4
- piggyback gnome-bluetile-session off gnome-fallback session
- drop the gnome bluetile.session file

* Fri Feb 17 2012 Jens Petersen <petersen@redhat.com> - 0.6-3
- gnome-bluetile-session: only start bluetile from gnome-session

* Fri Jan  6 2012 Jens Petersen <petersen@redhat.com> - 0.6-2
- update to cabal2spec-0.25.2

* Sun Dec 11 2011 Jens Petersen <petersen@redhat.com> - 0.6-1
- update to 0.6
- drop bluetile-0.5.3-WMName.patch for now

* Thu Oct 20 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.5.3-13.2
- rebuild with new gmp without compat lib

* Mon Oct 10 2011 Peter Schiffer <pschiffe@redhat.com> - 0.5.3-13.1
- rebuild with new gmp

* Mon Sep 26 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-13
- rebuild against newer deps

* Mon Aug 29 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-12
- rebuild for hslogger-1.1.5 and xmonad-contrib

* Wed Jun 22 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-11
- BR ghc-Cabal-devel and use ghc_excluded_archs (cabal2spec-0.23.2)

* Mon May 23 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-10
- use bluetile for WMName
- replace gnome-bluetile-session with a script

* Thu May 12 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-9
- patch the WMName to be Bluetile

* Fri Apr 22 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-8
- add back gnome-bluetile-session.desktop patched to "gnome-session --session="
  which simplifies our readme file considerably

* Wed Apr 20 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-7
- add a GNOME3 session file
- update the readme file to GNOME 3 gsettings

* Mon Apr 18 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-6
- revert the subpackaging since Cabal is linking all the executables
  with gtk and glade anyway

* Sat Apr 16 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-5
- subpackage the core window-manager program: it is doesn't depend on gtk2hs
- gnome-session uses gconf to find window-manager:
- remove gnome-bluetile-session, since WINDOW_MANAGER doesn't work by default
- add a readme file explaining the gconf and other ways of setting up

* Mon Apr  4 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-4
- use upstream's desktop files

* Fri Apr  1 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-3
- use desktop-file-install to install bluetile.desktop (#426753)
- fix the desktop files for desktop-install-validate
- add manpages (#426753)

* Wed Mar 16 2011 Jens Petersen <petersen@redhat.com> - 0.5.3-2
- update to cabal2spec-0.22.5
- add ConfigFile and regex-compat deps

* Mon Sep 13 2010 Jens Petersen <petersen@redhat.com> - 0.5.3-1
- BSD license
- homepage url
- BR xmonad-contrib, gtk, glade haskell libs
- add .desktop files like those in xmonad

* Mon Sep 13 2010 Fedora Haskell SIG <haskell-devel@lists.fedoraproject.org> - 0.5.3-0
- initial packaging for Fedora automatically generated by cabal2spec-0.22.2
